#!/usr/bin/perl
# WebHome 3.0
# Signup
# Made by CyberScript
# website: http://www.cyberscript.net
# email: webmaster@cyberscript.net
# (C) Copyright 1999, All rights reserved.
# DO NO EDIT THIS SCRIPT
##########################################

use Fcntl;
use AnyDBM_File;

require "cgi-lib.pl";
require "html.pl";
&ReadParse;

$current_date=time;
# script config...
open(CONFIG_TXT,"config.txt") || &error("Config file is missing. did you install yet?");
@config=<CONFIG_TXT>;
close (CONFIG);
foreach $line (@config) {
	chop $line if ($line =~ /\n/);
	($name,$value)=split(/=/,$line,2);
	$config{$name}=$value;
}

open (HEADER,"$config{'data_dir'}/header.txt");
while (<HEADER>) { $header.=$_; }
close (HEADER);
open (FOOTER,"$config{'data_dir'}/footer.txt");
while (<FOOTER>) { $footer.=$_; }
close (FOOTER);

if (!$in{'signup'}) {

	# SIGNUP COMMUNITIES HTML

	if ($config{'use_communities'} eq "yes") {
		$signup_communities_html = qq~
          <table border="0" cellpadding="0" cellspacing="0">
            <tr>
              <td width="120"><div align="right"><p><font face="Arial">Community</font></td>
              <td><font face="Arial"><small>&nbsp;</small><select name="community" size="1"
              style="background-color: rgb(255,255,255)">
~;
		opendir(COMMUNITIES,"$config{'data_dir'}/communities");
		@communities=readdir(COMMUNITIES);
		@communities = sort {lc($a) cmp lc($b)} @communities;
		closedir(COMMUNTIES);
		foreach $line (@communities) {
			if (-d "$config{'data_dir'}/communities/$line" && $line ne "." && $line ne "..") {
				if ($in{'communty'} eq $line) {
					$signup_communities_html .= qq~<option selected>$line</option>
~;
				} else {
					$signup_communities_html .= qq~<option>$line</option>
~;
				}
			}
		}
		$signup_communities_html .= qq~
              </select></font></td>
            </tr>
          </table>
~;
	}

	# SIGNUP QUESTIONS HTML
	open (QUESTIONS,"$config{'data_dir'}/questions.txt");
	@questions=<QUESTIONS>;
	close (QUESTIONS);
	foreach $line (@questions) {
		@line=split(/\|/,$line);
		$input=$line[0];
		$input =~ s/ /_/g;
		$input = lc($input);
		$signup_questions_html .= qq~
          <table border="0" cellpadding="0" cellspacing="0">
            <tr>
              <td width="120"><div align="right"><p><font face="Arial">$line[0]</font></td>
              <td><small><font face="Arial">&nbsp;<input type="text" name="$input" size="20"
              style="background-color: rgb(255,255,255)" value="$in{$input}"></font></small></td>
            </tr>
          </table>
~;
	}

	# TERMS AND CONDITIONS
	open (TERMS,"$config{'data_dir'}/terms.txt");
	while (<TERMS>) { $_ =~ s/\n/<br>/; $terms.=$_; }
	close (TERMS);

	print "Content-type: text/html\n\n";
	print &signup_html;

} else {
	# Get values
	$in{'username'}=lc($in{'username'});

	if ($config{'use_validation'} eq "yes") {
		$rtime = time;
		srand($rtime);
		$val_number ="";
		@idset = ('1'..'9');
		for ($i = 0; $i < 8; $i++) {
			$randum_num = int(rand($#idset + 1));
			$val_number .= @idset[$randum_num];
		}
	}

	$flags = O_CREAT | O_RDWR;
	$db = "$config{'data_dir'}/users";
	tie(%users, 'AnyDBM_File', $db , $flags, 0666) || print &manager_error_html("Cant open user database");

	# Check errors
	&error("username is missing") if (!$in{'username'});
	&error("username is taken") if ($users{$in{'username'}});
	@reserved=split(/,/,$config{'reserved_names'});
	foreach $line (@reserved) { &error("username has been reserved") if ($in{'username'} eq $line);	}	

	&error("illegal characters in username") unless ($in{'username'} =~ /^[a-z0-9\-\_]*$/);
	&error("username needs to be atleast $config{'min_username'} in length") if (length($in{'username'}) < $config{'min_username'});
	&error("username needs to be less then $config{'max_username'} in length") if (length($in{'username'}) > $config{'max_username'});

	&error("password is missing") if (!$in{'password'});
	&error("illegal characters in password") unless ($in{'password'} =~ /^[a-z0-9\-\_]*$/i);
	&error("password needs to be atleast $config{'min_password'} in length") if (length($in{'password'}) < $config{'min_password'});
	&error("password needs to be less then $config{'max_password'} in length") if (length($in{'password'}) > $config{'max_password'});

	&error("missing email address") if (!$in{'email'});
	&error("invalid email address") if ($in{'email'} !~ /\@/);

	if ($config{'distinct_accounts'} eq "yes") {
		while (($key, $value) = each %users) {
			@value=split(/\|/,$value);
			&error("there is already a account registered to that email") if ($value[1] eq $in{'email'});
		}
	}

	&error("missing real name") if (!$in{'real_name'});

	&error("missing site description") if (!$in{'site_description'} && $config{'require_description'} eq "yes");
	&error("site description must be less then $config{'max_description'} in length") if (length($in{'site_description'}) > $config{'max_description'});

	&error("missing community") if (!$in{'community'} && $config{'use_community'} eq "yes");

	open (QUESTIONS,"$config{'data_dir'}/questions.txt");
	@questions=<QUESTIONS>;
	close (QUESTIONS);
	foreach $line (@questions) {
		@line=split(/\|/,$line);
		$input=$line[0];
		$input =~ s/ /_/g;
		$input = lc($input);
		&error("$line[0] is missing") if (!$in{$input} && $line[1] eq "yes");
	}

	mkdir ("$config{'data_dir'}/users/$in{'username'}", 0755);

	if ($config{'use_communities'} eq "yes") {
		mkdir ("$config{'root_dir'}/$in{'community'}/$in{'username'}", 0755);
		unless (-f "$config{'root_dir'}/$in{'community'}/$in{'username'}/index.html") {
			open (INDEX_HTML,">$config{'root_dir'}/$in{'community'}/$in{'username'}/index.html");
			open (DEFAULT_HTML,"$config{'data_dir'}/communities/$in{'community'}/default_html.txt");
			while (<DEFAULT_HTML>) {
				$_ =~ s/!userNick!/$in{'username'}/gi;
				$_ =~ s/!userName!/$in{'real_name'}/gi;
				$_ =~ s/!userDescription!/$in{'site_description'}/gi;
				$_ =~ s/!userEmail!/$in{'email'}/gi;
				print INDEX_HTML $_;
			}
			close (DEFAULT_HTML);
			close (INDEX_HTML);
		}
	} else {
		mkdir ("$config{'root_dir'}/$in{'username'}", 0755);
		unless (-f "$config{'root_dir'}/$in{'username'}/index.html") {
			open (INDEX_HTML,">$config{'root_dir'}/$in{'username'}/index.html");
			open (DEFAULT_HTML,"$config{'data_dir'}/default_html.txt");
			while (<DEFAULT_HTML>) { print INDEX_HTML $_; }
			close (DEFAULT_HTML);
			close (INDEX_HTML);
		}
	}

	$current_date=time;
	if ($config{'use_validation'} eq "yes") { $status = "validation"; } else { $status = "enabled"; }

	$users{$in{'username'}} = "$in{'password'}|$in{'email'}|$in{'site_description'}|$current_date|$status|$config{'default_group'}|$in{'real_name'}|$in{'community'}|";

	open (USER_CONFIG,">$config{'data_dir'}/users/$in{'username'}/config.txt");

	if ($config{'use_validation'} eq "yes") { print USER_CONFIG "val_number=$val_number\n"; }
	open (QUESTIONS,"$config{'data_dir'}/questions.txt");
	@questions=<QUESTIONS>;
	close (QUESTIONS);
	foreach $line (@questions) {
		@line=split(/\|/,$line);
		$input=$line[0];
		$input =~ s/ /_/g;
		$input=lc($input);
		print USER_CONFIG "$input=$in{$input}\n";
	}
	close (USER_CONFIG);

	if ($config{'use_communities'} eq "yes") {
		while (($key, $value) = each %users) {
			@value=split(/\|/,$value);
			push (@community_users, "$key|$value[2]|") if ($value[7] eq $in{'community'});
		}
		@community_users = sort {uc($a) cmp uc($b)} @community_users;

		open (HEADER,"$config{'data_dir'}/communities/$in{'community'}/header.txt");
		while (<HEADER>) { $list_header .= $_; }
		close (HEADER);
		open (FOOTER,"$config{'data_dir'}/communities/$in{'community'}/footer.txt");
		while (<FOOTER>) { $list_footer .= $_; }
		close (FOOTER);

		foreach $line (@community_users) {
			@line=split(/\|/,$line);
			if ($line[1]) {
				$user_list .= qq~  <li><font face="Arial"><strong><a href="$config{'root_url'}/$in{'community'}/$line[0]/">$line[0]</a><br>
    </strong>$line[1]</font></li>
~;
			} else {
				$user_list .= qq~  <li><font face="Arial"><strong><a href="$config{'root_url'}/$in{'community'}/$line[0]/">$line[0]</a></strong></font></li>
~;
			}
		}

		open (INDEX,">$config{'root_dir'}/$in{'community'}/index.html");
		print INDEX &user_list_html;
		close (INDEX);

	} else {

		$list_header=$header;
		$list_footer=$footer;

		while (($key, $value) = each %users) {
			@value=split(/\|/,$value);
			push (@users, "$key|$value[2]|") if (!$value[7]);
		}
		@users = sort {uc($a) cmp uc($b)} @users;

		foreach $line (@users) {
			@line=split(/\|/,$line);
			if ($line[1]) {
				$user_list .= qq~  <li><font face="Arial"><strong><a href="$config{'root_url'}/$line[0]/">$line[0]</a><br>
    </strong>$line[1]</font></li>
~;
			} else {
				$user_list .= qq~  <li><font face="Arial"><strong><a href="$config{'root_url'}/$line[0]/">$line[0]</a></strong></font></li>
~;
			}
		}

		open (INDEX,">$config{'root_dir'}/list.html");
		print INDEX &user_list_html;
		close (INDEX);
	}

	untie(%users);

	if ($config{'use_log'} eq "yes") {
		open (LOG,">>$config{'data_dir'}/log.txt");
		$time=localtime(time);
		print LOG "[$time] $in{'username'} has signed up for a account\n";
		close (LOG);
	}

	$pid=fork();
	if ($pid) {

		open (QUESTIONS,"$config{'data_dir'}/questions.txt");
		@questions=<QUESTIONS>;
		close (QUESTIONS);
		foreach $line (@questions) {
			@line=split(/\|/,$line);
			$input=$line[0];
			$input =~ s/ /_/g;
			$input = lc($input);
			$signup_success_questions .= "            $line[0]: $in{$input}<br>\n";
		}

		if ($config{'use_validation'} eq "yes") {
			$signup_success_validation_field = qq~
              <table border="0" cellpadding="0" cellspacing="0">
                <tr>
                  <td width="120"><font face="Arial">validation #</font></td>
                  <td><input type="text" name="valNumber" size="20"></td>
                </tr>
              </table>
~;
		}

		print "Content-type: text/html\n\n";
		print &signup_success_html;

	} else {
		close (STOUT);
		open (MAIL,"|$config{'sendmail'} -t");
		print MAIL "To: $in{'email'}\n";
		print MAIL "From: $config{'admin_email'}\n";
		print MAIL "Subject: WebHome account\n";
		print MAIL qq~
W E B H O M E    3 . 0    S I G N U P

Username: $in{'username'}
Password: $in{'password'}
Email: $in{'email'}
Real name: $in{'real_name'}
Site description: $in{'site_description'}
Community: $in{'community'}
~;
		if ($config{'use_validation'} eq "yes") { print MAIL "Validation #: $val_number\n"; }
		open (QUESTIONS,"$config{'data_dir'}/questions.txt");
		@questions=<QUESTIONS>;
		close (QUESTIONS);
		foreach $line (@questions) {
			@line=split(/\|/,$line);
			$input=$line[0];
			$input =~ s/ /_/g;
			$input = lc($input);
			print MAIL "$line[0]: $in{$input}\n";
		}
		print MAIL qq~
------------------------------------

~;
		open (WELCOME_MESSAGE,"$config{'data_dir'}/welcome.txt");
		while (<WELCOME_MESSAGE>) { print MAIL $_; }
		close (WELCOME_MESSAGE);
		close (MAIL);
	}
}

sub error {
	($error)=@_;

	if ($config{'use_communities'} eq "yes") {
		$signup_error_communities_html = qq~
          <table border="0" cellpadding="0" cellspacing="0">
            <tr>
              <td width="120"><div align="right"><p><font face="Arial">Community</font></td>
              <td><font face="Arial"><small>&nbsp;</small><select name="community" size="1"
              style="background-color: rgb(255,255,255)">
~;
		opendir(COMMUNITIES,"$config{'data_dir'}/communities");
		@communities=readdir(COMMUNITIES);
		closedir(COMMUNTIES);
		foreach $line (@communities) {
			if (-d "$config{'data_dir'}/communities/$line" && $line ne "." && $line ne "..") {
				if ($in{'communty'} eq $line) {
					$signup_error_communities_html .= qq~<option selected>$line</option>
~;
				} else {
					$signup_error_communities_html .= qq~<option>$line</option>
~;
				}
			}
		}
		$signup_error_communities_html .= qq~
              </select></font></td>
            </tr>
          </table>
~;
	}

	open (QUESTIONS,"$config{'data_dir'}/questions.txt");
	@questions=<QUESTIONS>;
	close (QUESTIONS);
	foreach $line (@questions) {
		@line=split(/\|/,$line);
		$input=$line[0];
		$input =~ s/ /_/g;
		$input = lc($input);
		$signup_error_questions_html .= qq~
          <table border="0" cellpadding="0" cellspacing="0">
            <tr>
              <td width="120"><div align="right"><p><font face="Arial">$line[0]</font></td>
              <td><small><font face="Arial">&nbsp;<input type="text" name="$input" size="20"
              style="background-color: rgb(255,255,255)" value="$in{$input}"></font></small></td>
            </tr>
          </table>
		~;
	}

	print "Content-type: text/html\n\n";
	print &signup_error_html;

	exit;
}